# ]po[ ITSM Helpdesk
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](http://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](http://www.project-open.com/en/list-installers)

About ]po[ ITSM Helpdesk:

<p><p>The Helpdesk package is an incident and change management system. It can be used to keep track of interaction by clients and providers in Service Level Agreements (SLA), as a central place for client requests to be captured and starting point for the provider response and continual tracking until the request issue has been resolved. These operations fall under the category of &quot;ticket management&quot;, and the Helpdesk has a wide range of functionality, having the ability to closely track Incidents such as Bug or SLA Requests, or Change, such as Feature, Training, Purchasing, etc., Requests. <p><img src="http://www.project-open.com/images/manual_screenshots/intranet_helpdesk_index.png" /><p><font size="2"> Screenshot show a list display of all the Helpdesk &quot;tickets&quot; currently on the system.</font><h3><font size="2"></font>Bar charts for quick Status Overview: </h3><p><img src="http://www.project-open.com/images/manual_screenshots/intranet_sla_management_tickets_per_ticket-status.png" /><img src="http://www.project-open.com/images/manual_screenshots/intranet_sla_management_tickets_per_ticket_type.png" /><img src="http://www.project-open.com/images/manual_screenshots/intranet_sla_management_tickets_per_ticket_owner.png" /><img src="http://www.project-open.com/images/manual_screenshots/intranet_sla_management_daily_ticket_status_change.png" /><span style="font-weight: bold;"></span><span style="font-weight: bold;"></span>

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/lib/similar-tickets.adp">lib/similar-tickets.adp</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/lib/similar-tickets.tcl">lib/similar-tickets.tcl</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/lib/ticket-age-per-queue.adp">lib/ticket-age-per-queue.adp</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/lib/ticket-age-per-queue.tcl">lib/ticket-age-per-queue.tcl</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/lib/ticket-aging.adp">lib/ticket-aging.adp</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/lib/ticket-aging.tcl">lib/ticket-aging.tcl</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/lib/ticket-timeline.adp">lib/ticket-timeline.adp</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/lib/ticket-timeline.tcl">lib/ticket-timeline.tcl</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=191275&amp;path=packages/intranet-helpdesk/tcl/intranet-helpdesk-procs.tcl">tcl/intranet-helpdesk-procs.tcl</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/procs-file-view?version_id=191275&amp;path=packages/intranet-helpdesk/tcl/sourceforge-import-procs.tcl">tcl/sourceforge-import-procs.tcl</a></b></td><td></td><td></td></tr></table>

## Procedures

<table cellpadding="0" cellspacing="0"><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_home_component">im_helpdesk_home_component</a></b></td><td></td><td>Returns a HTML table with the list of tickets of the current user. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_inbox_pop3_import_sweeper">im_helpdesk_inbox_pop3_import_sweeper</a></b></td><td></td><td>Check for new mail to be converted into tickets </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_member_add_queue_component">im_helpdesk_member_add_queue_component</a></b></td><td></td><td>Component that returns a formatted HTML form allowing users to add queues to a ticket. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_new_ticket_ticket_rel">im_helpdesk_new_ticket_ticket_rel</a></b></td><td></td><td>Mark the ticket (ticket_id) as a duplicate of ticket_id_from_search </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_project_component">im_helpdesk_project_component</a></b></td><td></td><td>Returns a HTML table with the list of tickets for the current project. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_related_objects_component">im_helpdesk_related_objects_component</a></b></td><td></td><td>Returns a HTML component with the list of related tickets. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_related_tickets_component">im_helpdesk_related_tickets_component</a></b></td><td></td><td>Replaced by im_helpdesk_related_objects_component </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_similar_tickets_component">im_helpdesk_similar_tickets_component</a></b></td><td></td><td>Returns a HTML table with a list of tickets that are somehow &quot;related&quot; to the current ticket based on full-text similarity, configuration items, users etc. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_sourceforge_tracker_import_sweeper">im_helpdesk_sourceforge_tracker_import_sweeper</a></b></td><td></td><td>Loads the RSS contents of a SF tracker and inserts the ticktes into ]po[. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_ticket_age_number_per_queue">im_helpdesk_ticket_age_number_per_queue</a></b></td><td></td><td>Returns a HTML component with a bar chart with tickets and age per queue </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_ticket_aging_diagram">im_helpdesk_ticket_aging_diagram</a></b></td><td></td><td>Returns a HTML component with a pie chart with top customer </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_ticket_component">im_helpdesk_ticket_component</a></b></td><td></td><td>Returns a HTML table with the list of tickets of the current user. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_ticket_queue_options">im_helpdesk_ticket_queue_options</a></b></td><td></td><td>Returns a list of Ticket Queue tuples suitable for ad_form </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_helpdesk_ticket_sla_options">im_helpdesk_ticket_sla_options</a></b></td><td></td><td>Returns a list of SLA tuples suitable for ad_form on which the current_user_id can add tickets </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_menu_tickets_admin_links">im_menu_tickets_admin_links</a></b></td><td></td><td>Return a list of admin links to be added to the &quot;projects&quot; menu </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_navbar_tree_helpdesk">im_navbar_tree_helpdesk</a></b></td><td></td><td>Creates an &lt;ul&gt; ...&lt;/ul&gt; collapsable menu for the system&#39;s main NavBar. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_navbar_tree_helpdesk_ticket_type">im_navbar_tree_helpdesk_ticket_type</a></b></td><td></td><td>Show one of {Issue|Incident|Problem|Change} Management </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_package_helpdesk_id">im_package_helpdesk_id</a></b></td><td></td><td>Returns the package id of the intranet-helpdesk module </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::add_reply">im_ticket::add_reply</a></b></td><td></td><td>Add a comment to the ticket as forum topic of type &quot;reply&quot;. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::audit">im_ticket::audit</a></b></td><td></td><td>Write the audit trail </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::check_permissions">im_ticket::check_permissions</a></b></td><td></td><td>Check if the user can perform view, read, write or admin the ticket </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::close_forum">im_ticket::close_forum</a></b></td><td></td><td>Set the ticket forum to &quot;deleted&quot; </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::close_workflow">im_ticket::close_workflow</a></b></td><td></td><td>Stop the ticket workflow. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::internal_sla_id">im_ticket::internal_sla_id</a></b></td><td></td><td>Determines the &quot;internal&quot; SLA: This SLA is used for handling meta-tickets, such as a request to create an SLA for a user. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::new">im_ticket::new</a></b></td><td></td><td>Create a new ticket. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::next_ticket_nr">im_ticket::next_ticket_nr</a></b></td><td></td><td>Create a new ticket_nr. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::notification::get_url">im_ticket::notification::get_url</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::notification_subscribe">im_ticket::notification_subscribe</a></b></td><td></td><td>Subscribe a user to notifications on a specific ticket. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::notification_unsubscribe">im_ticket::notification_unsubscribe</a></b></td><td></td><td>Unsubscribe a user to notifications on a specific ticket. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::set_status_id">im_ticket::set_status_id</a></b></td><td></td><td>Set the ticket to the specified status. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket::update_timestamp">im_ticket::update_timestamp</a></b></td><td></td><td>Set the specified timestamp(s) to now() </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_action_close">im_ticket_action_close</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_action_close_delete">im_ticket_action_close_delete</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_action_close_notify">im_ticket_action_close_notify</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_action_duplicated">im_ticket_action_duplicated</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_navbar">im_ticket_navbar</a></b></td><td></td><td>Returns rendered HTML code for a horizontal sub-navigation bar for /intranet/projects/. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_nuke">im_ticket_nuke</a></b></td><td></td><td>Nuke (complete delete from the database) a ticket. </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_options">im_ticket_options</a></b></td><td></td><td>Returns a list of Tickets suitable for ad_form </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_permission_read_sql">im_ticket_permission_read_sql</a></b></td><td></td><td>Returns a SQL statement that returns the list of ticket_ids that are readable for the user </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_permissions">im_ticket_permissions</a></b></td><td></td><td>Fill the &quot;by-reference&quot; variables read, write and admin with the permissions of $user_id on $ticket_id </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_accepted">im_ticket_status_accepted</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_assigned">im_ticket_status_assigned</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_canceled">im_ticket_status_canceled</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_cantreproduce">im_ticket_status_cantreproduce</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_closed">im_ticket_status_closed</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_customer_review">im_ticket_status_customer_review</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_deleted">im_ticket_status_deleted</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_duplicate">im_ticket_status_duplicate</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_frozen">im_ticket_status_frozen</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_internal_review">im_ticket_status_internal_review</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_invalid">im_ticket_status_invalid</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_open">im_ticket_status_open</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_outdated">im_ticket_status_outdated</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_rejected">im_ticket_status_rejected</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_resolved">im_ticket_status_resolved</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_waiting_for_other">im_ticket_status_waiting_for_other</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_status_wontfix">im_ticket_status_wontfix</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_timeline_component">im_ticket_timeline_component</a></b></td><td></td><td>A set of dates during a ticket lifecycle </td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_bug_request">im_ticket_type_bug_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_change_ticket">im_ticket_type_change_ticket</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_comment_request">im_ticket_type_comment_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_feature_request">im_ticket_type_feature_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_generic_problem_ticket">im_ticket_type_generic_problem_ticket</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_idea">im_ticket_type_idea</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_incident_ticket">im_ticket_type_incident_ticket</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_nagios_alert">im_ticket_type_nagios_alert</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_permission_request">im_ticket_type_permission_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_problem_ticket">im_ticket_type_problem_ticket</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_project_change_request">im_ticket_type_project_change_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_project_request">im_ticket_type_project_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_purchase_request">im_ticket_type_purchase_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_report_request">im_ticket_type_report_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_sla_request">im_ticket_type_sla_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_telephony_request">im_ticket_type_telephony_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_training_request">im_ticket_type_training_request</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_user_story">im_ticket_type_user_story</a></b></td><td></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/proc-view?version_id=191275&amp;proc=im_ticket_type_workplace_move_request">im_ticket_type_workplace_move_request</a></b></td><td></td><td></td></tr></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/intranet-helpdesk-callbacks.sql&amp;version_id=191275">sql/postgresql/intranet-helpdesk-callbacks.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/intranet-helpdesk-create.sql&amp;version_id=191275">sql/postgresql/intranet-helpdesk-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/intranet-helpdesk-drop.sql&amp;version_id=191275">sql/postgresql/intranet-helpdesk-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/intranet-helpdesk-notifications-create.sql&amp;version_id=191275">sql/postgresql/intranet-helpdesk-notifications-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/intranet-helpdesk-portlets-create.sql&amp;version_id=191275">sql/postgresql/intranet-helpdesk-portlets-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/upgrade/upgrade-5.0.1.0.0-5.0.1.0.1.sql&amp;version_id=191275">sql/postgresql/upgrade/upgrade-5.0.1.0.0-5.0.1.0.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/upgrade/upgrade-5.0.2.4.0-5.0.2.4.1.sql&amp;version_id=191275">sql/postgresql/upgrade/upgrade-5.0.2.4.0-5.0.2.4.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/workflow-feature_request_wf-create.sql&amp;version_id=191275">sql/postgresql/workflow-feature_request_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/workflow-sla_request_wf-create.sql&amp;version_id=191275">sql/postgresql/workflow-sla_request_wf-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=intranet-helpdesk&amp;url=postgresql/workflow-ticket_generic_wf-create.sql&amp;version_id=191275">sql/postgresql/workflow-ticket_generic_wf-create.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b>www/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-accepted.tcl">action-accepted.tcl</a></b></td><td>Mark tickets as &quot;accepted&quot;</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-associate-2.adp">action-associate-2.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-associate-2.tcl">action-associate-2.tcl</a></b></td><td>Associate the ticket_ids in &quot;tid&quot; with one of the specified objects.</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-associate.adp">action-associate.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-associate.tcl">action-associate.tcl</a></b></td><td>Allow the user to associate the current ticket with a new object using an OpenACS relationship.</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-change-priority-2.adp">action-change-priority-2.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-change-priority-2.tcl">action-change-priority-2.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-change-priority.adp">action-change-priority.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-change-priority.tcl">action-change-priority.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-confirmed.tcl">action-confirmed.tcl</a></b></td><td>Mark tickets as &quot;confirmed&quot;</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-duplicated.tcl">action-duplicated.tcl</a></b></td><td>We get here after the user has choosen the &quot;Duplicate&quot; action of a ticket.</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-reassign-2.adp">action-reassign-2.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-reassign-2.tcl">action-reassign-2.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-reassign.adp">action-reassign.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-reassign.tcl">action-reassign.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action-signoff.tcl">action-signoff.tcl</a></b></td><td>Mark tickets as &quot;confirmed&quot;</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/action.tcl">action.tcl</a></b></td><td>Perform bulk actions on tickets</td></tr><tr valign="top"><td><b>admin/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/admin/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/admin/index.tcl">index.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/dashboard.adp">dashboard.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/dashboard.tcl">dashboard.tcl</a></b></td><td>Ticket Dashboard</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/index.adp">index.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/index.tcl">index.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/new-typeselect.adp">new-typeselect.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/new-typeselect.tcl">new-typeselect.tcl</a></b></td><td>We get redirected here from the ticket&#39;s &quot;New&quot; page if there are DynFields per object subtype and no type is specified.</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/new.adp">new.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/new.tcl">new.tcl</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/notify-stakeholders.adp">notify-stakeholders.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/notify-stakeholders.tcl">notify-stakeholders.tcl</a></b></td><td>Notify everybody related to a number of tickets.</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/nuke-2.adp">nuke-2.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/nuke-2.tcl">nuke-2.tcl</a></b></td><td>Remove a user from the system completely</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/nuke.adp">nuke.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/nuke.tcl">nuke.tcl</a></b></td><td>Remove a ticket completely</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/quote.adp">quote.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/quote.tcl">quote.tcl</a></b></td><td></td></tr><tr valign="top"><td><b>reporting/</b></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/reporting/ticket-by-customer-dept.tcl">ticket-by-customer-dept.tcl</a></b></td><td>Shows the results of the evaluated users</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/request-sla-2.adp">request-sla-2.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/request-sla-2.tcl">request-sla-2.tcl</a></b></td><td>This page is called if a user is not a member of any SLA and doesn&#39;t have the right to see all tickets.</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/request-sla.adp">request-sla.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/request-sla.tcl">request-sla.tcl</a></b></td><td>This page is called if a user is not a member of any SLA and doesn&#39;t have the right to see all tickets.</td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/ticket-select.adp">ticket-select.adp</a></b></td><td></td></tr><tr valign="top"><td style="width:35%"><b><a href="http://www.project-open.net/api-doc/content-page-view?version_id=191275&amp;path=packages/intranet-helpdesk/www/ticket-select.tcl">ticket-select.tcl</a></b></td><td>Shows a list of &quot;Problem tickets&quot; to which we can related the current &quot;Incident Ticket&quot;.</td></tr></table>

